Merge branch 'stable-2.8' into stable-2.9
[ganeti-local] / Makefile.am
index 668b007..c359728 100644 (file)
@@ -20,6 +20,9 @@ strip_hsroot = $(patsubst src/%,%,$(patsubst test/hs/%,%,$(1)))
 # Use bash in order to be able to use pipefail
 SHELL=/bin/bash
 
+# Enable colors in shelltest
+SHELLTESTARGS = "-c"
+
 ACLOCAL_AMFLAGS = -I autotools
 BUILD_BASH_COMPLETION = $(top_srcdir)/autotools/build-bash-completion
 RUN_IN_TEMPDIR = $(top_srcdir)/autotools/run-in-tempdir
@@ -63,8 +66,6 @@ myexeclibdir = $(pkglibdir)
 HS_DIRS = \
        src \
        src/Ganeti \
-       src/Ganeti/Block \
-       src/Ganeti/Block/Drbd \
        src/Ganeti/Confd \
        src/Ganeti/Curl \
        src/Ganeti/DataCollectors \
@@ -75,11 +76,17 @@ HS_DIRS = \
        src/Ganeti/Hypervisor/Xen \
        src/Ganeti/Monitoring \
        src/Ganeti/Query \
+       src/Ganeti/Storage \
+       src/Ganeti/Storage/Diskstats \
+       src/Ganeti/Storage/Drbd \
+       src/Ganeti/Storage/Lvm \
        test/hs \
        test/hs/Test \
        test/hs/Test/Ganeti \
-       test/hs/Test/Ganeti/Block \
-       test/hs/Test/Ganeti/Block/Drbd \
+       test/hs/Test/Ganeti/Storage \
+       test/hs/Test/Ganeti/Storage/Diskstats \
+       test/hs/Test/Ganeti/Storage/Drbd \
+       test/hs/Test/Ganeti/Storage/Lvm \
        test/hs/Test/Ganeti/Confd \
        test/hs/Test/Ganeti/HTools \
        test/hs/Test/Ganeti/HTools/Backend \
@@ -104,6 +111,7 @@ DIRS = \
        test/data/htools \
        test/data/htools/rapi \
        test/hs/shelltests \
+       test/autotools \
        lib \
        lib/build \
        lib/client \
@@ -194,6 +202,8 @@ CLEANFILES = \
        $(man_MANS) \
        $(manhtml) \
        tools/kvm-ifup \
+       tools/vif-ganeti \
+       tools/net-common \
        tools/users-setup \
        tools/vcluster-setup \
        stamp-directories \
@@ -202,6 +212,7 @@ CLEANFILES = \
        $(HS_ALL_PROGS) $(HS_BUILT_SRCS) \
        $(HS_BUILT_TEST_HELPERS) \
        src/ganeti-confd \
+       src/ganeti-luxid \
        src/ganeti-mond \
        .hpc/*.mix src/*.tix test/hs/*.tix \
        doc/hs-lint.html
@@ -215,7 +226,7 @@ HS_GENERATED_FILES =
 if WANT_HTOOLS
 HS_GENERATED_FILES += $(HS_PROGS)
 if ENABLE_CONFD
-HS_GENERATED_FILES += src/hconfd src/ganeti-confd
+HS_GENERATED_FILES += src/hconfd src/ganeti-confd src/hluxid src/ganeti-luxid
 endif
 
 if ENABLE_MOND
@@ -244,6 +255,7 @@ BUILT_EXAMPLES = \
        doc/examples/ganeti-kvm-poweroff.initd \
        doc/examples/ganeti.cron \
        doc/examples/ganeti.initd \
+       doc/examples/ganeti.logrotate \
        doc/examples/ganeti-master-role.ocf \
        doc/examples/ganeti-node-role.ocf \
        doc/examples/gnt-config-backup \
@@ -423,6 +435,7 @@ docinput = \
        doc/design-2.5.rst \
        doc/design-2.6.rst \
        doc/design-2.7.rst \
+       doc/design-2.8.rst \
        doc/design-autorepair.rst \
        doc/design-bulk-create.rst \
        doc/design-chained-jobs.rst \
@@ -488,6 +501,7 @@ endif
 HS_COMPILE_PROGS= \
        src/ganeti-mond \
        src/hconfd \
+       src/hluxid \
        src/rpc-test
 
 # All Haskell non-test programs to be compiled but not automatically installed
@@ -530,22 +544,24 @@ HPCEXCL = --exclude Main \
        $(patsubst src.%,--exclude Test.%,$(subst /,.,$(patsubst %.hs,%, $(HS_LIB_SRCS))))
 
 HS_LIB_SRCS = \
-       src/Ganeti/Block/Drbd/Types.hs \
-       src/Ganeti/Block/Drbd/Parser.hs \
        src/Ganeti/BasicTypes.hs \
        src/Ganeti/Common.hs \
        src/Ganeti/Compat.hs \
        src/Ganeti/Confd/Client.hs \
+       src/Ganeti/Confd/ClientFunctions.hs \
        src/Ganeti/Confd/Server.hs \
        src/Ganeti/Confd/Types.hs \
        src/Ganeti/Confd/Utils.hs \
        src/Ganeti/Config.hs \
+       src/Ganeti/ConfigReader.hs \
        src/Ganeti/Curl/Multi.hs \
        src/Ganeti/Daemon.hs \
        src/Ganeti/DataCollectors/CLI.hs \
+       src/Ganeti/DataCollectors/Diskstats.hs \
        src/Ganeti/DataCollectors/Drbd.hs \
        src/Ganeti/DataCollectors/InstStatus.hs \
        src/Ganeti/DataCollectors/InstStatusTypes.hs \
+       src/Ganeti/DataCollectors/Lv.hs \
        src/Ganeti/DataCollectors/Program.hs \
        src/Ganeti/DataCollectors/Types.hs \
        src/Ganeti/Errors.hs \
@@ -562,6 +578,7 @@ HS_LIB_SRCS = \
        src/Ganeti/HTools/Group.hs \
        src/Ganeti/HTools/Instance.hs \
        src/Ganeti/HTools/Loader.hs \
+       src/Ganeti/HTools/Nic.hs \
        src/Ganeti/HTools/Node.hs \
        src/Ganeti/HTools/PeerMap.hs \
        src/Ganeti/HTools/Program/Hail.hs \
@@ -589,6 +606,7 @@ HS_LIB_SRCS = \
        src/Ganeti/OpCodes.hs \
        src/Ganeti/OpParams.hs \
        src/Ganeti/Path.hs \
+       src/Ganeti/Query/Cluster.hs \
        src/Ganeti/Query/Common.hs \
        src/Ganeti/Query/Export.hs \
        src/Ganeti/Query/Filter.hs \
@@ -603,6 +621,13 @@ HS_LIB_SRCS = \
        src/Ganeti/Rpc.hs \
        src/Ganeti/Runtime.hs \
        src/Ganeti/Ssconf.hs \
+       src/Ganeti/Storage/Diskstats/Parser.hs \
+       src/Ganeti/Storage/Diskstats/Types.hs \
+       src/Ganeti/Storage/Drbd/Parser.hs \
+       src/Ganeti/Storage/Drbd/Types.hs \
+       src/Ganeti/Storage/Lvm/LVParser.hs \
+       src/Ganeti/Storage/Lvm/Types.hs \
+       src/Ganeti/Storage/Utils.hs \
        src/Ganeti/THH.hs \
        src/Ganeti/Types.hs \
        src/Ganeti/Utils.hs
@@ -610,8 +635,6 @@ HS_LIB_SRCS = \
 HS_TEST_SRCS = \
        test/hs/Test/Ganeti/Attoparsec.hs \
        test/hs/Test/Ganeti/BasicTypes.hs \
-       test/hs/Test/Ganeti/Block/Drbd/Parser.hs \
-       test/hs/Test/Ganeti/Block/Drbd/Types.hs \
        test/hs/Test/Ganeti/Common.hs \
        test/hs/Test/Ganeti/Confd/Types.hs \
        test/hs/Test/Ganeti/Confd/Utils.hs \
@@ -643,6 +666,10 @@ HS_TEST_SRCS = \
        test/hs/Test/Ganeti/Rpc.hs \
        test/hs/Test/Ganeti/Runtime.hs \
        test/hs/Test/Ganeti/Ssconf.hs \
+       test/hs/Test/Ganeti/Storage/Diskstats/Parser.hs \
+       test/hs/Test/Ganeti/Storage/Drbd/Parser.hs \
+       test/hs/Test/Ganeti/Storage/Drbd/Types.hs \
+       test/hs/Test/Ganeti/Storage/Lvm/LVParser.hs \
        test/hs/Test/Ganeti/THH.hs \
        test/hs/Test/Ganeti/TestCommon.hs \
        test/hs/Test/Ganeti/TestHTools.hs \
@@ -846,7 +873,7 @@ test/hs/hpc-htools: HEXTRA_INT=-fhpc
 test/hs/hpc-mon-collector: HEXTRA_INT=-fhpc
 
 # test dependency
-test/hs/offline-tests.sh: test/hs/hpc-htools test/hs/hpc-mon-collector
+test/hs/offline-test.sh: test/hs/hpc-htools test/hs/hpc-mon-collector
 
 # rules for building profiling-enabled versions of the haskell
 # programs: hs-prof does the full two-step build, whereas
@@ -881,7 +908,11 @@ if ENABLE_CONFD
 src/ganeti-confd: src/hconfd
        cp -f $< $@
 
+src/ganeti-luxid: src/hluxid
+       cp -f $< $@
+
 nodist_sbin_SCRIPTS += src/ganeti-confd
+nodist_sbin_SCRIPTS += src/ganeti-luxid
 endif
 
 if ENABLE_MOND
@@ -927,6 +958,8 @@ nodist_pkglib_python_scripts = \
 myexeclib_SCRIPTS = \
        daemons/daemon-util \
        tools/kvm-ifup \
+       tools/vif-ganeti \
+       tools/net-common \
        $(pkglib_python_scripts) \
        $(HS_MYEXECLIB_PROGS)
 
@@ -962,6 +995,8 @@ EXTRA_DIST = \
        devel/upload \
        devel/webserver \
        tools/kvm-ifup.in \
+       tools/vif-ganeti.in \
+       tools/net-common.in \
        tools/users-setup.in \
        tools/vcluster-setup.in \
        $(docinput) \
@@ -993,6 +1028,7 @@ EXTRA_DIST = \
 man_MANS = \
        man/ganeti-cleaner.8 \
        man/ganeti-confd.8 \
+       man/ganeti-luxid.8 \
        man/ganeti-listrunner.8 \
        man/ganeti-masterd.8 \
        man/ganeti-mond.8 \
@@ -1013,6 +1049,7 @@ man_MANS = \
        man/gnt-os.8 \
        man/gnt-storage.8 \
        man/hail.1 \
+       man/harep.1 \
        man/hbal.1 \
        man/hcheck.1 \
        man/hinfo.1 \
@@ -1034,11 +1071,15 @@ maninput = \
        $(mangen)
 
 TEST_FILES = \
+       test/autotools/autotools-check-news.test \
        test/data/htools/clean-nonzero-score.data \
        test/data/htools/common-suffix.data \
        test/data/htools/empty-cluster.data \
        test/data/htools/hail-alloc-drbd.json \
+       test/data/htools/hail-alloc-invalid-network.json \
        test/data/htools/hail-alloc-invalid-twodisks.json \
+       test/data/htools/hail-alloc-restricted-network.json \
+       test/data/htools/hail-alloc-spindles.json \
        test/data/htools/hail-alloc-twodisks.json \
        test/data/htools/hail-change-group.json \
        test/data/htools/hail-invalid-reloc.json \
@@ -1046,7 +1087,13 @@ TEST_FILES = \
        test/data/htools/hail-reloc-drbd.json \
        test/data/htools/hbal-excl-tags.data \
        test/data/htools/hbal-split-insts.data \
+       test/data/htools/hspace-tiered-dualspec-exclusive.data \
        test/data/htools/hspace-tiered-dualspec.data \
+       test/data/htools/hspace-tiered-exclusive.data \
+       test/data/htools/hspace-tiered-ipolicy.data \
+       test/data/htools/hspace-tiered-mixed.data \
+       test/data/htools/hspace-tiered-resourcetypes.data \
+       test/data/htools/hspace-tiered-vcpu.data \
        test/data/htools/hspace-tiered.data \
        test/data/htools/invalid-node.data \
        test/data/htools/missing-resources.data \
@@ -1057,6 +1104,8 @@ TEST_FILES = \
        test/data/htools/rapi/info.json \
        test/data/htools/rapi/instances.json \
        test/data/htools/rapi/nodes.json \
+       test/data/htools/hroller-full.data \
+       test/data/htools/hroller-nodegroups.data \
        test/data/htools/hroller-nonredundant.data \
        test/data/htools/hroller-online.data \
        test/data/htools/unique-reboot-order.data \
@@ -1077,6 +1126,7 @@ TEST_FILES = \
        test/data/bdev-drbd-8.0.txt \
        test/data/bdev-drbd-8.3.txt \
        test/data/bdev-drbd-8.4.txt \
+       test/data/bdev-drbd-8.4-no-disk-params.txt \
        test/data/bdev-drbd-disk.txt \
        test/data/bdev-drbd-net-ip4.txt \
        test/data/bdev-drbd-net-ip6.txt \
@@ -1097,6 +1147,7 @@ TEST_FILES = \
        test/data/cluster_config_2.7.json \
        test/data/cluster_config_2.8.json \
        test/data/instance-minor-pairing.txt \
+       test/data/instance-prim-sec.txt \
        test/data/ip-addr-show-dummy0.txt \
        test/data/ip-addr-show-lo-ipv4.txt \
        test/data/ip-addr-show-lo-ipv6.txt \
@@ -1110,6 +1161,9 @@ TEST_FILES = \
        test/data/kvm_0.9.1_help_boot_test.txt \
        test/data/kvm_1.0_help.txt \
        test/data/kvm_1.1.2_help.txt \
+       test/data/lvs_lv.txt \
+       test/data/NEWS_OK.txt \
+       test/data/NEWS_previous_unreleased.txt \
        test/data/ovfdata/compr_disk.vmdk.gz \
        test/data/ovfdata/config.ini \
        test/data/ovfdata/corrupted_resources.ovf \
@@ -1135,6 +1189,7 @@ TEST_FILES = \
        test/data/ovfdata/wrong_manifest.ovf \
        test/data/ovfdata/wrong_ova.ova \
        test/data/ovfdata/wrong_xml.ovf \
+       test/data/proc_diskstats.txt \
        test/data/proc_drbd8.txt \
        test/data/proc_drbd80-emptyline.txt \
        test/data/proc_drbd80-emptyversion.txt \
@@ -1160,6 +1215,7 @@ TEST_FILES = \
        test/py/gnt-cli.test \
        test/py/import-export_unittest-helper
 
+
 python_tests = \
        doc/examples/rapi_testutils.py \
        test/py/cfgupgrade_unittest.py \
@@ -1167,11 +1223,14 @@ python_tests = \
        test/py/ganeti.asyncnotifier_unittest.py \
        test/py/ganeti.backend_unittest-runasroot.py \
        test/py/ganeti.backend_unittest.py \
+       test/py/ganeti.bootstrap_unittest.py \
        test/py/ganeti.cli_unittest.py \
        test/py/ganeti.client.gnt_cluster_unittest.py \
        test/py/ganeti.client.gnt_instance_unittest.py \
        test/py/ganeti.client.gnt_job_unittest.py \
        test/py/ganeti.cmdlib_unittest.py \
+       test/py/ganeti.cmdlib.cluster_unittest.py \
+       test/py/ganeti.cmdlib.instance_storage_unittest.py \
        test/py/ganeti.compat_unittest.py \
        test/py/ganeti.confd.client_unittest.py \
        test/py/ganeti.config_unittest.py \
@@ -1233,6 +1292,7 @@ python_tests = \
        test/py/ganeti.utils.nodesetup_unittest.py \
        test/py/ganeti.utils.process_unittest.py \
        test/py/ganeti.utils.retry_unittest.py \
+       test/py/ganeti.utils.storage_unittest.py \
        test/py/ganeti.utils.text_unittest.py \
        test/py/ganeti.utils.wrapper_unittest.py \
        test/py/ganeti.utils.x509_unittest.py \
@@ -1251,8 +1311,11 @@ dist_TESTS = \
        test/py/ganeti-cleaner_unittest.bash \
        test/py/import-export_unittest.bash \
        test/py/cli-test.bash \
-       test/py/bash_completion.bash \
-       $(python_tests)
+       test/py/bash_completion.bash
+
+if PY_UNIT
+dist_TESTS += $(python_tests)
+endif
 
 nodist_TESTS =
 check_SCRIPTS =
@@ -1285,7 +1348,6 @@ all_python_code = \
        $(pkglib_python_scripts) \
        $(nodist_pkglib_python_scripts) \
        $(nodist_tools_python_scripts) \
-       $(python_tests) \
        $(pkgpython_PYTHON) \
        $(client_PYTHON) \
        $(cmdlib_PYTHON) \
@@ -1303,6 +1365,10 @@ all_python_code = \
        $(noinst_PYTHON) \
        $(qa_scripts)
 
+if PY_UNIT
+all_python_code += $(python_tests)
+endif
+
 srclink_files = \
        man/footer.rst \
        test/py/check-cert-expired_unittest.bash \
@@ -1362,6 +1428,14 @@ tools/kvm-ifup: tools/kvm-ifup.in $(REPLACE_VARS_SED)
        sed -f $(REPLACE_VARS_SED) < $< > $@
        chmod +x $@
 
+tools/vif-ganeti: tools/vif-ganeti.in $(REPLACE_VARS_SED)
+       sed -f $(REPLACE_VARS_SED) < $< > $@
+       chmod +x $@
+
+tools/net-common: tools/net-common.in $(REPLACE_VARS_SED)
+       sed -f $(REPLACE_VARS_SED) < $< > $@
+       chmod +x $@
+
 tools/users-setup: tools/users-setup.in $(REPLACE_VARS_SED)
        sed -f $(REPLACE_VARS_SED) < $< > $@
        chmod +x $@
@@ -1514,8 +1588,6 @@ lib/_autoconf.py: Makefile | stamp-directories
          echo "XEN_KERNEL = '$(XEN_KERNEL)'"; \
          echo "XEN_INITRD = '$(XEN_INITRD)'"; \
          echo "KVM_KERNEL = '$(KVM_KERNEL)'"; \
-         echo "FILE_STORAGE_DIR = '$(FILE_STORAGE_DIR)'"; \
-         echo "ENABLE_FILE_STORAGE = $(ENABLE_FILE_STORAGE)"; \
          echo "SHARED_FILE_STORAGE_DIR = '$(SHARED_FILE_STORAGE_DIR)'"; \
          echo "ENABLE_SHARED_FILE_STORAGE = $(ENABLE_SHARED_FILE_STORAGE)"; \
          echo "IALLOCATOR_SEARCH_PATH = [$(IALLOCATOR_SEARCH_PATH)]"; \
@@ -1540,6 +1612,8 @@ lib/_autoconf.py: Makefile | stamp-directories
          echo "RAPI_GROUP = '$(RAPI_GROUP)'"; \
          echo "CONFD_USER = '$(CONFD_USER)'"; \
          echo "CONFD_GROUP = '$(CONFD_GROUP)'"; \
+         echo "LUXID_USER = '$(LUXID_USER)'"; \
+         echo "LUXID_GROUP = '$(LUXID_GROUP)'"; \
          echo "NODED_USER = '$(NODED_USER)'"; \
          echo "NODED_GROUP = '$(NODED_GROUP)'"; \
          echo "MOND_USER = '$(MOND_USER)'"; \
@@ -1615,17 +1689,18 @@ $(REPLACE_VARS_SED): $(SHELL_ENV_INIT) Makefile stamp-directories
          echo 's#@''CUSTOM_XEN_INITRD@#$(XEN_INITRD)#g'; \
          echo 's#@''CUSTOM_IALLOCATOR_SEARCH_PATH@#$(IALLOCATOR_SEARCH_PATH)#g'; \
          echo 's#@''CUSTOM_EXPORT_DIR@#$(EXPORT_DIR)#g'; \
-         echo 's#@''RPL_FILE_STORAGE_DIR@#$(FILE_STORAGE_DIR)#g'; \
          echo 's#@''RPL_SSH_INITD_SCRIPT@#$(SSH_INITD_SCRIPT)#g'; \
          echo 's#@''PKGLIBDIR@#$(pkglibdir)#g'; \
          echo 's#@''GNTMASTERUSER@#$(MASTERD_USER)#g'; \
          echo 's#@''GNTRAPIUSER@#$(RAPI_USER)#g'; \
          echo 's#@''GNTCONFDUSER@#$(CONFD_USER)#g'; \
+         echo 's#@''GNTLUXIDUSER@#$(LUXID_USER)#g'; \
          echo 's#@''GNTNODEDUSER@#$(NODED_USER)#g'; \
          echo 's#@''GNTMONDUSER@#$(MOND_USER)#g'; \
          echo 's#@''GNTRAPIGROUP@#$(RAPI_GROUP)#g'; \
          echo 's#@''GNTADMINGROUP@#$(ADMIN_GROUP)#g'; \
          echo 's#@''GNTCONFDGROUP@#$(CONFD_GROUP)#g'; \
+         echo 's#@''GNTLUXIDGROUP@#$(LUXID_GROUP)#g'; \
          echo 's#@''GNTMASTERDGROUP@#$(MASTERD_GROUP)#g'; \
          echo 's#@''GNTMONDGROUP@#$(MOND_GROUP)#g'; \
          echo 's#@''GNTDAEMONSGROUP@#$(DAEMONS_GROUP)#g'; \
@@ -1736,28 +1811,30 @@ check-local: check-dirs $(GENERATED_FILES)
        $(CHECK_VERSION) $(VERSION) $(top_srcdir)/NEWS
        RELEASE=$(PACKAGE_VERSION) $(CHECK_NEWS) < $(top_srcdir)/NEWS
        PYTHONPATH=. $(RUN_IN_TEMPDIR) $(CURDIR)/$(CHECK_IMPORTS) . $(standalone_python_modules)
-       @expver=$(VERSION_MAJOR).$(VERSION_MINOR); \
        error= ; \
-       if test "`head -n 1 $(top_srcdir)/README`" != "Ganeti $$expver"; then \
-         echo "Incorrect version in README, expected $$expver" >&2; \
-         error=1; \
-       fi; \
-       for file in doc/iallocator.rst doc/hooks.rst doc/virtual-cluster.rst \
-           doc/security.rst; do \
-         if test "`sed -ne '4 p' $(top_srcdir)/$$file`" != \
-           "Documents Ganeti version $$expver"; then \
-           echo "Incorrect version in $$file, expected $$expver" >&2; \
+       if [ "x`echo $(VERSION_SUFFIX)|grep 'alpha'`" == "x" ]; then \
+         expver=$(VERSION_MAJOR).$(VERSION_MINOR); \
+         if test "`head -n 1 $(top_srcdir)/README`" != "Ganeti $$expver"; then \
+           echo "Incorrect version in README, expected $$expver" >&2; \
+           error=1; \
+         fi; \
+         for file in doc/iallocator.rst doc/hooks.rst doc/virtual-cluster.rst \
+             doc/security.rst; do \
+           if test "`sed -ne '4 p' $(top_srcdir)/$$file`" != \
+             "Documents Ganeti version $$expver"; then \
+             echo "Incorrect version in $$file, expected $$expver" >&2; \
+             error=1; \
+           fi; \
+         done; \
+         if ! test -f $(top_srcdir)/doc/design-$$expver.rst; then \
+           echo "File $(top_srcdir)/doc/design-$$expver.rst not found" >&2; \
+           error=1; \
+         fi; \
+         if test "`sed -ne '5 p' $(top_srcdir)/doc/design-draft.rst`" != \
+           ".. Last updated for Ganeti $$expver"; then \
+           echo "doc/design-draft.rst was not updated for version $$expver" >&2; \
            error=1; \
          fi; \
-       done; \
-       if ! test -f $(top_srcdir)/doc/design-$$expver.rst; then \
-         echo "File $(top_srcdir)/doc/design-$$expver.rst not found" >&2; \
-         error=1; \
-       fi; \
-       if test "`sed -ne '5 p' $(top_srcdir)/doc/design-draft.rst`" != \
-         ".. Last updated for Ganeti $$expver"; then \
-         echo "doc/design-draft.rst was not updated for version $$expver" >&2; \
-         error=1; \
        fi; \
        for file in configure.ac $(HS_LIBTEST_SRCS) $(HS_PROG_SRCS); do \
          if test $$(wc --max-line-length < $(top_srcdir)/$$file) -gt 80; then \
@@ -1767,15 +1844,30 @@ check-local: check-dirs $(GENERATED_FILES)
        done; \
        test -z "$$error"
 
+.PHONY: hs-test-%
+hs-test-%: test/hs/htest | $(BUILT_PYTHON_SOURCES)
+       @rm -f htest.tix
+       test/hs/htest -t $*
+
 .PHONY: hs-tests
 hs-tests: test/hs/htest | $(BUILT_PYTHON_SOURCES)
        @rm -f htest.tix
        ./test/hs/htest
 
+.PHONY: hs-shell-%
+hs-shell-%: test/hs/hpc-htools test/hs/hpc-mon-collector \
+            $(HS_BUILT_TEST_HELPERS)
+       @rm -f hpc-htools.tix hpc-mon-collector.tix
+       HBINARY="./test/hs/hpc-htools" \
+       SHELLTESTARGS=$(SHELLTESTARGS) \
+       ./test/hs/offline-test.sh $*
+
 .PHONY: hs-shell
 hs-shell: test/hs/hpc-htools test/hs/hpc-mon-collector $(HS_BUILT_TEST_HELPERS)
        @rm -f hpc-htools.tix hpc-mon-collector.tix
-       HBINARY="./test/hs/hpc-htools" ./test/hs/offline-test.sh
+       HBINARY="./test/hs/hpc-htools" \
+       SHELLTESTARGS=$(SHELLTESTARGS) \
+       ./test/hs/offline-test.sh
 
 .PHONY: hs-check
 hs-check: hs-tests hs-shell
@@ -1971,12 +2063,17 @@ TAGS: $(GENERATED_FILES)
          etags -l python -a -
 
 .PHONY: coverage
+
+COVERAGE_TESTS=
 if WANT_HTOOLS
-coverage: py-coverage hs-coverage
-else
-coverage: py-coverage
+COVERAGE_TESTS += hs-coverage
+endif
+if PY_UNIT
+COVERAGE_TESTS += py-coverage
 endif
 
+coverage: $(COVERAGE_TESTS)
+
 .PHONY: py-coverage
 py-coverage: $(GENERATED_FILES) $(python_tests)
        @test -n "$(PYCOVERAGE)" || \
@@ -2017,7 +2114,12 @@ live-test: all
          --srcdir=.. $(HPCEXCL) ; \
        hpc report --srcdir=.. live-test $(HPCEXCL)
 
-commit-check: distcheck lint apidoc
+commit-check: autotools-check distcheck lint apidoc
+
+autotools-check:
+       TESTDATA_DIR=./test/data shelltest $(SHELLTESTARGS) \
+  $(abs_top_srcdir)/test/autotools/*-*.test \
+  -- --hide-successes
 
 .PHONY: gitignore-check
 gitignore-check: